<?php
//EDITED OCTOBER 24,2010 - FORCE SNMP VERSION TO 0 DUE TO SOME CACTI BUGS DURING DATA QUERY PROCESS
/* do NOT run this script through a web browser */
if (!isset($_SERVER["argv"][0]) || isset($_SERVER['REQUEST_METHOD'])  || isset($_SERVER['REMOTE_ADDR'])) {
   die("<br><strong>This script is only meant to run at the command line.</strong>");
}

$no_http_headers = true;

include(dirname(__FILE__) . "/../include/global.php");
include(dirname(__FILE__) . "/../lib/snmp.php");

$oids = array(
        "index" => ".1.3.6.1.4.1.193.72.1000.10.1.1.6.1.1.0.0.11.1.3.6.1.2.1.2.2.1.1",
        "ifin" => ".1.3.6.1.4.1.193.72.1000.10.1.1.6.1.1.0.0.11.1.3.6.1.2.1.2.2.1.10.",
        "ifout" => ".1.3.6.1.4.1.193.72.1000.10.1.1.6.1.1.0.0.11.1.3.6.1.2.1.2.2.1.16",
        );

$hostname       = $_SERVER["argv"][1];
$host_id        = $_SERVER["argv"][2];
$snmp_auth      = $_SERVER["argv"][3];
$cmd            = $_SERVER["argv"][4];

/* support for SNMP V2 and SNMP V3 parameters */
$snmp = explode(":", $snmp_auth);
$snmp_version   = $snmp[0];
$snmp_port      = $snmp[1];
$snmp_timeout   = $snmp[2];
$ping_retries   = $snmp[3];
$max_oids               = $snmp[4];

$snmp_auth_username     = "";
$snmp_auth_password     = "";
$snmp_auth_protocol     = "";
$snmp_priv_passphrase   = "";
$snmp_priv_protocol     = "";
$snmp_context           = "";
$snmp_community                 = "";

if ($snmp_version == 3) {
        $snmp_auth_username   = $snmp[6];
        $snmp_auth_password   = $snmp[7];
        $snmp_auth_protocol   = $snmp[8];
        $snmp_priv_passphrase = $snmp[9];
        $snmp_priv_protocol   = $snmp[10];
        $snmp_context         = $snmp[11];
}else{
        $snmp_community = $snmp[5];
}

/*
 * process INDEX requests
 */
if ($cmd == "index") {
        $arr_index = get_indexes($hostname, $snmp_community, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, SNMP_POLLER);

        for ($i=1;$i<25;$i++) {
                print $arr_index[$i] . "\n";
        }

/*
 * process QUERY requests
 */
}elseif ($cmd == "query") {
        $arg = $_SERVER["argv"][5];

        $arr_index = get_indexes($hostname, $snmp_community, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids);
        $ifin = get_ifin($hostname, $snmp_community, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids);
        $ifout = get_ifout($hostname, $snmp_community, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids);
        $description = get_description($hostname, $snmp_community, "0", $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids);
        for ($i=1;$i<25;$i++) {
                if ($arg == "ifin") {
                        print $arr_index[$i] . "!" . $ifin[$i] . "\n";
                }elseif ($arg == "ifout") {
                        print $arr_index[$i] . "!" . $ifout[$i] . "\n";
                }elseif ($arg == "description") {
                        print $arr_index[$i] . "!" . $description[$i] . "\n";
                }elseif ($arg == "index") {
                        print $arr_index[$i] . "!" . $arr_index[$i] . "\n";
                }
        }
}elseif ($cmd == "get") {
        $arg = $_SERVER["argv"][5];
        $index = $_SERVER["argv"][6];
        $arr = array();

//      $arr_index = get_indexes($hostname, $snmp_community, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids);
        if ($arg == "ifin") {
                $arr = get_ifin($hostname, $snmp_community, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, $index);       
        }elseif ($arg == "ifout") {
                $arr = get_ifout($hostname, $snmp_community, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, $index);
        }elseif ($arg == "description") {
                $arr = get_description($hostname, $snmp_community, "0", $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids);
        }
//      if (isset($arr_index[$index])) {
                print $arr[$index];
//      }
}

function get_ifin($hostname, $snmp_community, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, $index) {
//      $arr = reindex(cacti_snmp_walk($hostname, $snmp_community, ".1.3.6.1.4.1.193.72.1000.10.1.1.6.1.1.0.0.11.1.3.6.1.2.1.2.2.1.10", $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, SNMP_POLLER));
        $return_arr = array();

//      $j = 0;

//      for ($i=1;$i<25;$i++) {
                $return_arr[$index] = cacti_snmp_get($hostname, $snmp_community, ".1.3.6.1.4.1.193.72.1000.10.1.1.6.1.1.0.0.11.1.3.6.1.2.1.2.2.1.10." .$index, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, SNMP_POLLER);
//              }

        return $return_arr;
}

function get_ifout($hostname, $snmp_community, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, $index) {
//      $arr = reindex(cacti_snmp_walk($hostname, $snmp_community, ".1.3.6.1.4.1.193.72.1000.10.1.1.6.1.1.0.0.11.1.3.6.1.2.1.2.2.1.10", $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, SNMP_POLLER));
        $return_arr = array();

//      $j = 0;

//      for ($i=1;$i<25;$i++) {
                $return_arr[$index] = cacti_snmp_get($hostname, $snmp_community, ".1.3.6.1.4.1.193.72.1000.10.1.1.6.1.1.0.0.11.1.3.6.1.2.1.2.2.1.16." .$index, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, SNMP_POLLER);
//              }

        return $return_arr;
}

function get_description($hostname, $snmp_community, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids) {
        $arr = reindex(cacti_snmp_walk($hostname, $snmp_community, ".1.3.6.1.4.1.193.72.1000.10.1.1.6.1.1.0.0.11.1.3.6.1.2.1.2.2.1.10", $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, SNMP_POLLER));
        $return_arr = array();

        $j = 0;

        for ($i=1;$i<25;$i++) {
                $return_arr[$i] = "Ethernet Port " . $i;
                }

        return $return_arr;
}



function get_indexes($hostname, $snmp_community, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids) {
        $arr = reindex(cacti_snmp_walk($hostname, $snmp_community, ".1.3.6.1.2.1.25.3.3.1", $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, SNMP_POLLER));
        $return_arr = array();

        $j = 0;

        for ($i=1;$i<25;$i++) {
                        $return_arr[$i] = $i;
                }


        return $return_arr;
}

function reindex($arr) {
        $return_arr = array();

        for ($i=1;$i<25;$i++) {
                        $return_arr[$i] = $i;
                }


        return $return_arr;
}

?>